/* widgetSize.C

   Copyright (C) 1999 by David Rose.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   To contact the original author of this program, write to:
           David Rose
           224 W. Dryden St Apt. 418
	   Glendale, CA 91202
	   USA

	   drose@lafn.org
   */

#include "system.h"

#include "widgetSize.h"

static int
restore_usize(Gtk_Widget *widget) {
  widget->set_usize(0, 0);
  return false;
}

void
request_initial_size(Gtk_Widget &widget, int xsize, int ysize) {
  if (xsize != 0 || ysize != 0) {
    // I can't find a way to request an initial size for a general
    // widget.  The best I can do is specify its minimum size.
    widget.set_usize(xsize, ysize);
    
    // However, I don't want the minimum size to be enforced forever;
    // the user should be able to resize the window smaller if he wants
    // to.  Thus, this ugly hack: at the first idle signal, we return
    // the usize to 0.
    connect_to_function(Gtk_Main::idle(), &restore_usize, &widget);
  }
}

