/* songPlayer.h

   Copyright (C) 1999 by David Rose.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   To contact the original author of this program, write to:
           David Rose
           224 W. Dryden St Apt. 418
	   Glendale, CA 91202
	   USA

	   drose@lafn.org
   */

#ifndef SONGPLAYER_H
#define SONGPLAYER_H

#include <gtk--.h>

class SongPlayer : public Gtk_Signal_Base {
public:
  SongPlayer();
  virtual ~SongPlayer();

  bool is_valid() const;

  virtual void reset()=0;
  virtual bool is_playing() const=0;
  virtual double get_current_pos() const=0;
  virtual void play(double start, double end)=0;
  virtual void stop()=0;
  virtual void idle()=0;

  Signal0 stopped_at_end;

protected:
  bool _is_valid;
};

#endif
